#include "papu_internals.hh"
#include "papu_dmcgenunit.hh"

void dmcgen::write(fBYTE ind, fBYTE value)
{
	#if PAPU_DMC_DEBUG
    fprintf(stderr, "dmc::write(%u, 0x%02X)", ind, value);
    #endif
	if(!ind)
	{
        static const WORD wlenconvdata[16] =
        {0xD60, 0xBE0, 0xAA0, 0xA00,
         0x8F0, 0x7F0, 0x710, 0x6B0,
         0x5F0, 0x500, 0x470, 0x400,
         0x350, 0x2A0, 0x240, 0x1B0};
         
        wavelen = wlenconvdata[value & 15];
		playbackmode = value >> 6;
		irqflag = false;
		#if PAPU_DMC_DEBUG
		fprintf(stderr, "(wlen %u, mode %d, irq flag reset)", wavelen, playbackmode);
		#endif
	}
	else if(ind==1)
	{
		deltacounter = value & 127;
		#if PAPU_DMC_DEBUG
		fprintf(stderr, "(counter=0x%02X)", value & 127);
		#endif
	}
	else if(ind==2)
	{
		loadaddr = ((fWORD)value << 6) | 0xC000;
		playaddr = loadaddr;
		#if PAPU_DMC_DEBUG
		fprintf(stderr, "(loading address=%X)", loadaddr);
		#endif
	}
	else if(ind==3)
	{
		dmalen = (fWORD)value << 4;
		lengthleft = dmalen;
		#if PAPU_DMC_DEBUG
		fprintf(stderr, "(length=%u)", dmalen);
		#endif
	}
	#if PAPU_DMC_DEBUG
	fprintf(stderr, "\n");
	#endif
}

